namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Water Bubble is an ability that halves the damage taken from Fire-type moves and prevents the Pokémon from being burned.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Water_Bubble_(Ability)">Bulbapedia - Water Bubble</see>
/// </summary>
[Script(ScriptCategory.Ability, "water_bubble")]
public class WaterBubble : Script, IScriptChangeIncomingMoveDamage, IScriptChangeMoveDamage, IScriptPreventStatusChange
{
    /// <inheritdoc />
    public void PreventStatusChange(IPokemon pokemon, StringKey status, bool selfInflicted, ref bool preventStatus)
    {
        if (status == ScriptUtils.ResolveName<Status.Burned>())
            preventStatus = true;
    }

    /// <inheritdoc />
    public void ChangeIncomingMoveDamage(IExecutingMove move, IPokemon target, byte hit, ref uint damage)
    {
        if (move.GetHitData(target, hit).Type?.Name == "fire")
            damage /= 2;
    }

    /// <inheritdoc />
    public void ChangeMoveDamage(IExecutingMove move, IPokemon target, byte hit, ref uint damage)
    {
        if (move.GetHitData(target, hit).Type?.Name == "water")
            damage *= 2;
    }
}